// eigen_solvers_wrappers.h -*-c++-*-
#ifndef _eigen_solvers_wrappers_HDR_
#define _eigen_solvers_wrappers_HDR_

#include<boost/numeric/ublas/matrix.hpp>
#include<boost/numeric/ublas/matrix_sparse.hpp>
#include<boost/numeric/ublas/vector.hpp>

#include<vector>
#include<complex>

#include<sparse_matrices.h>

namespace pu{
  template<typename SC> class LAL_TypeEigDriverNonSym;

  template<> class LAL_TypeEigDriverNonSym<double>{

    typedef boost::numeric::ublas::compressed_matrix
    <double,boost::numeric::ublas::column_major> matrix_t;

    typedef umf_factorized<double>
    factorized_t;

    factorized_t factorized;
    boost::shared_ptr<matrix_t const> pK;

    //workspaces
    int ido;
    char const bmat;
    int const n;
    std::string which;
    int nev;
    double tol;
    boost::numeric::ublas::vector<double> resid;
    int ncv;
    boost::numeric::ublas::matrix<double,boost::numeric::ublas::column_major>v;
    int ldv;
    boost::numeric::ublas::c_vector<int,11> iparam;
    boost::numeric::ublas::c_vector<int,14> ipntr;
    boost::numeric::ublas::vector<double> workd;
    boost::numeric::ublas::vector<double> workl;
    int lworkl;
    int info;
    
  public:
    LAL_TypeEigDriverNonSym(boost::shared_ptr<matrix_t const> const &pMi,
			    boost::shared_ptr<matrix_t const> const &pKi);
    void solve(double const tol_in,std::string const &which_in,
	       unsigned const nev_in);

    // non const since we still passing workspaces
    void get_all_converged_eigs(std::vector<std::complex<double> > &result);
  };

}//of pu
#endif
